<script setup lang="ts">
import { ref, onMounted } from "vue";
import type { QInput, QTableProps } from "quasar";
import { useCounterMixin } from "@/stores/mixin";
import { useRoute } from "vue-router";
import { usePositionDataStore } from "@/modules/01_metadataNew/stores/positionListStore";
import { useMainOptionDataStore } from "@/modules/01_metadataNew/stores/main";
import { usePositionTypeDataStore } from "@/modules/01_metadataNew/stores/positionTypeStore";
import dialogHeader from "@/components/DialogHeader.vue";
import { useQuasar } from "quasar";
import http from "@/plugins/http";
import config from "@/app.config";
const store = usePositionDataStore();
const storeOption = useMainOptionDataStore();
const storeName = usePositionTypeDataStore();

const mixin = useCounterMixin();

const posName = defineModel<string>("posName", {
  required: true,
});

const {
  dialogRemove,
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
} = mixin;
const $q = useQuasar();

const columns = [
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px; width:0px",
    style: "font-size: 14px",
  },
  {
    name: "posLevelName",
    align: "left",
    label: "ชื่อระดับตำแหน่ง",
    sortable: true,
    field: "posLevelName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posTypeName",
    align: "left",
    label: "ประเภทตำแหน่ง",
    sortable: true,
    field: "posTypeName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posLevelRank",
    align: "left",
    label: "ระดับของระดับตำแหน่ง",
    sortable: true,
    field: "posLevelRank",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posLevelAuthority",
    align: "left",
    label: "ผู้มีอำนาจสั่งบรรจุ",
    sortable: true,
    field: "posLevelAuthority",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "createdAt",
    align: "center",
    label: "วันที่สร้าง",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "lastUpdatedAt",
    align: "center",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
] as const satisfies QTableProps["columns"];
const route = useRoute();
const id = ref<string>(route.params.id.toString());
const filterKeyword = ref<string>("");
const dialog = ref<boolean>(false);
const dialogStatus = ref<string>("");
const editId = ref<string>("");
const posLevelName = ref<string>("");
const posLevelRank = ref<number>();
const posLevelAuthority = ref<string>("");
const posLevelNameRef = ref<QInput | null>(null);
const posLevelRankRef = ref<QInput | null>(null);
const posTypeIdRef = ref<QInput | null>(null);
const posLevelAuthorityRef = ref<QInput | null>(null);
const visibleColumns = ref<string[]>([
  "no",
  "posTypeName",
  "posLevelName",
  "posLevelRank",
  "posLevelAuthority",
]);

async function fetchData() {
  showLoader();
  await http
    .get(config.API.orgPosTypeId(id.value))
    .then(async (res) => {
      posName.value = res.data.result.posTypeName;
      store.save(res.data.result.posLevels);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function addData() {
  await http
    .post(config.API.orgPosLevel, {
      posLevelName: posLevelName.value,
      posLevelRank: posLevelRank.value,
      posLevelAuthority:
        posLevelAuthority.value == "" ? "" : posLevelAuthority.value,
      posTypeId: id.value,
    })
    .then(() => {
      fetchData();
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function editData(editId: string) {
  await http
    .put(config.API.orgPosLevelId(editId), {
      posLevelName: posLevelName.value,
      posLevelRank: posLevelRank.value,
      posLevelAuthority:
        posLevelAuthority.value == "" ? "" : posLevelAuthority.value,
      posTypeId: id.value,
    })
    .then(() => {
      fetchData();
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function deleteData(id: string) {
  await http
    .delete(config.API.orgPosLevelId(id))
    .then(() => {
      fetchData();
      success($q, "ลบข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

function closeDialog() {
  dialog.value = false;
}

function validateForm() {
  posLevelNameRef.value?.validate();
  posLevelRankRef.value?.validate();
  posTypeIdRef.value?.validate();
  posLevelAuthorityRef.value?.validate();
  onSubmit();
}

async function onSubmit() {
  if (
    posLevelName.value.length > 0 &&
    posLevelAuthority.value.length > 0 &&
    posLevelRank.value !== undefined &&
    posLevelRank.value > 0
  ) {
    dialogConfirm(
      $q,
      async () => {
        dialogStatus.value === "create" ? addData() : editData(editId.value);
        closeDialog();
      },
      "ยืนยันการบันทึกข้อมูล",
      "ต้องการยืนยันการบันทึกข้อมูลนี้หรือไม่ ?"
    );
  }
}

onMounted(async () => {
  fetchData();
});
</script>

<template>
  <div class="q-pa-md">
    <q-toolbar style="padding: 0">
      <q-btn
        flat
        round
        color="primary"
        icon="add"
        @click.stop="
          () => {
            dialogStatus = 'create';
            dialog = true;
            posLevelName = '';
            posLevelRank = undefined;
            posLevelAuthority = '';
          }
        "
      >
        <q-tooltip> เพิ่มข้อมูล </q-tooltip>
      </q-btn>
      <q-space />
      <div class="row q-gutter-sm">
        <q-input outlined dense v-model="filterKeyword" label="ค้นหา"></q-input>
        <q-select
          v-model="visibleColumns"
          multiple
          outlined
          dense
          options-dense
          :display-value="$q.lang.table.columns"
          emit-value
          map-options
          :options="columns"
          option-value="name"
          options-cover
          style="min-width: 150px"
        />
      </div>
    </q-toolbar>

    <d-table
      ref="table"
      :columns="columns"
      :rows="store.row"
      :filter="filterKeyword"
      row-key="name"
      flat
      bordered
      :paging="true"
      dense
      class="custom-header-table"
      :visible-columns="visibleColumns"
    >
      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            <span class="text-weight-bold">{{ col.label }}</span>
          </q-th>
          <q-th auto-width />
        </q-tr>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props" class="cursor-pointer">
          <q-td v-for="(col, index) in props.cols" :key="col.id">
            <div v-if="col.name === 'no'">
              {{ props.rowIndex + 1 }}
            </div>
            <div v-if="col.name === 'posTypeName'">
              {{ posName }}
            </div>
            <div v-else>
              {{ col.value }}
            </div>
          </q-td>
          <q-td auto-width>
            <q-btn
              color="edit"
              flat
              dense
              round
              class="q-mr-xs"
              size="12px"
              icon="edit"
              clickable
              @click.stop="
                () => {
                  dialogStatus = 'edit';
                  editId = props.row.id;
                  posLevelName = props.row.posLevelName;
                  posLevelRank = props.row.posLevelRank;
                  if (props.row.posLevelAuthority === 'หัวหน้าหน่วยงาน') {
                    posLevelAuthority = 'HEAD';
                  } else if (props.row.posLevelAuthority === 'ปลัด') {
                    posLevelAuthority = 'DEPUTY';
                  } else {
                    posLevelAuthority = 'GOVERNOR';
                  }

                  dialog = true;
                }
              "
            >
              <q-tooltip>แก้ไขข้อมูล</q-tooltip>
            </q-btn>
            <q-btn
              color="red"
              flat
              dense
              round
              size="12px"
              icon="mdi-delete"
              clickable
              @click.stop="
                dialogRemove($q, async () => await deleteData(props.row.id))
              "
              v-close-popup
            >
              <q-tooltip>ลบข้อมูล</q-tooltip>
            </q-btn>
          </q-td>
        </q-tr>
      </template>
    </d-table>

    <q-dialog v-model="dialog" class="dialog" persistent>
      <q-card style="width: 350px">
        <form @submit.prevent="validateForm">
          <q-card-section class="flex justify-between" style="padding: 0">
            <dialog-header
              :tittle="dialogStatus == 'edit' ? 'แก้ไขข้อมูล' : 'เพิ่มข้อมูล'"
              :close="closeDialog"
            />
          </q-card-section>

          <q-separator color="grey-4" />
          <q-card-section class="row q-gutter-y-md">
            <div class="col-12">
              <q-input
                outlined
                ref="posLevelNameRef"
                v-model="posLevelName"
                label="ชื่อระดับตำแหน่ง"
                dense
                lazy-rules
                borderless
                bg-color="white"
                hide-bottom-space
                :rules="[(val) => val.length > 0 || 'กรุณากรอกระดับตำแหน่ง']"
              />
            </div>

            <div class="col-12">
              <q-input
                ref="posLevelRankRef"
                outlined
                v-model="posLevelRank"
                label="ระดับ"
                dense
                lazy-rules
                borderless
                min="1"
                bg-color="white"
                :rules="[(val) => val > 0 || 'กรุณากรอกระดับ']"
                hide-bottom-space
                mask="############"
              />
            </div>

            <div class="col-12">
              <q-select
                ref="posLevelAuthorityRef"
                outlined
                v-model="posLevelAuthority"
                emit-value
                map-options
                :options="storeOption.posLevelAuthorityOption"
                option-value="id"
                label="ผู้มีอำนาจสั่งบรรจุ"
                dense
                lazy-rules
                :rules="[(val) => !!val || 'กรุณาเลือกผู้มีอำนาจสั่งบรรจุ']"
                borderless
                bg-color="white"
                hide-bottom-space
              />
            </div>

            <div class="col-12">
              <q-select
                ref="posTypeIdRef"
                v-model="posName"
                label="ประเภทตำแหน่ง"
                outlined
                dense
                bg-color="white"
                options-cover
                hide-bottom-space
                readonly
              />
            </div>
          </q-card-section>

          <q-card-actions align="right">
            <q-btn
              id="onSubmit"
              type="submit"
              dense
              unelevated
              label="บันทึก"
              color="public"
              class="q-px-md"
            >
              <q-tooltip>บันทึกข้อมูล</q-tooltip>
            </q-btn>
          </q-card-actions>
        </form>
      </q-card>
    </q-dialog>
  </div>
</template>

<style scoped lang="scss">
.border_custom {
  border-radius: 6px !important;
  border: 1px solid #e1e1e1;
}
$toggle-background-color-on: #06884d;
$toggle-background-color-off: darkgray;
$toggle-control-color: white;
$toggle-width: 40px;
$toggle-height: 25px;
$toggle-gutter: 3px;
$toggle-radius: 50%;
$toggle-control-speed: 0.15s;
$toggle-control-ease: ease-in;

// These are our computed variables
// change at your own risk.
$toggle-radius: $toggle-height / 2;
$toggle-control-size: $toggle-height - ($toggle-gutter * 2);

.toggle-control {
  display: block;
  position: relative;
  padding-left: $toggle-width;
  margin-bottom: 12px;
  cursor: pointer;
  font-size: 22px;
  user-select: none;

  input {
    position: absolute;
    opacity: 0;
    cursor: pointer;
    height: 0;
    width: 0;
  }

  input:checked ~ .control {
    background-color: $toggle-background-color-on;

    &:after {
      left: $toggle-width - $toggle-control-size - $toggle-gutter;
    }
  }

  .control {
    position: absolute;
    top: -7px;
    left: -15px;
    height: $toggle-height;
    width: $toggle-width;
    border-radius: $toggle-radius;
    background-color: $toggle-background-color-off;
    transition: background-color $toggle-control-speed $toggle-control-ease;

    &:after {
      content: "";
      position: absolute;
      left: $toggle-gutter;
      top: $toggle-gutter;
      width: $toggle-control-size;
      height: $toggle-control-size;
      border-radius: $toggle-radius;
      background: $toggle-control-color;
      transition: left $toggle-control-speed $toggle-control-ease;
    }
  }
}
</style>
